{{- /*
Renders the CODEOWNERS data for a given page.

There are three types of code owner IDs in the CODEOWNERS file:
- Email addresses (foo@example.org)
- Users (@user)
- Groups (@organization/group) (also known as teams)

If the code owner ID is a user, and if a valid service is specified when
calling this partial, we attempt to retrieve the user's name, link, and avatar
from the service. If we cannot retrieve the user's information, we assume this
is a non-existent user and nothing will be displayed.

In all other cases, the code owner ID will be displayed as is.

Why not retrieve group information from the service APIs? Because it requires
authentication, and that seems like a lot of effort/hassle for a small return.

@param {page} The page for which to retrieve the CODEOWNERS data.

@example {{- partial "codeowners.html" . }}
*/}}

{{- /* Build a single codeowner. */}}
{{- $name := . }}
{{- $type := "" }}
{{- if and (strings.HasPrefix $name "@") (strings.Contains $name "/") }}
  {{- $type = "group" }}
{{- else if strings.HasPrefix $name "@" }}
  {{- $type = "user" }}
{{- else if strings.Contains $name "@" }}
  {{- $type = "email" }}
{{- end }}

{{- $link := "" }}
{{- $img := "" }}

{{- $codeowner := "" }}
{{- $member := "" }}
{{- if eq $type "user" }}
  {{- $slug := strings.TrimPrefix "@" $name }}
  {{- $regex := printf `(?i)^%s$` $slug }}
  {{- $member = index (where site.Data.public.team "gitlab" "like" $regex) 0 }}
  {{- /*
    If no member found we use the public GitLab.com profile instead.
    */}}
  {{- if not $member }}
    {{- warnf "Code owner %s not found... falling back to public GitLab profile." $slug }}
    {{- $codeowner = (dict "type" $type "name" $slug "username" $slug "link" (printf "https://gitlab.com/%s" $slug) "img" $img) }}
  {{- end }}
{{- else if eq $type "group" }}
  {{- /* Uncomment to display groups. */}}
  {{- /*  {{- $codeOwners = $codeOwners | append (dict "type" $type "name" $name) }}  */}}
{{- else if eq $type "email" }}
  {{- /* Uncomment to display email addresses. */}}
  {{- /*  {{- $codeOwners = $codeOwners | append (dict "type" $type "name" $name) }}  */}}
{{- end }}

{{- /* Render. */}}
{{- with $member }}
  <div class="codeowner codeowner-with-image my-1">
    {{- partial "member/with-gitlab-link" $member}}
  </div>
{{- else }}
  {{- with $codeowner -}}
    {{- if .img }}
      <div class="codeowner codeowner-with-image">
        <a href="{{ .link }}" title="@{{ .username }}"><img class="codeowner-avatar" src="{{ .img.RelPermalink }}" width="{{ .img.Width }}" height="{{ .img.Height }}" alt="{{ .name }}">{{ .name }}</a>
      </div>
    {{- else }}
      <div class="codeowner">
        <code class="codeowner-username">@{{ .username }}</code>
      </div>
    {{- end }}
  {{- end }}
{{- end }}
